package com.example.assignment1;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;

import androidx.appcompat.app.AppCompatActivity;

public class MainActivity extends AppCompatActivity {

    protected CounterButtonSharedPreferenceHelper firstCounterButtonSharedPrefHelper;
    protected CounterButtonSharedPreferenceHelper secondCounterButtonSharedPrefHelper;
    protected CounterButtonSharedPreferenceHelper thirdCounterButtonSharedPrefHelper;

    protected Button settingsButton = null;

    protected Button firstCounterButton;
    protected Button secondCounterButton;
    protected Button thirdCounterButton;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        settingsButton = findViewById(R.id.settings_button);
        firstCounterButton = findViewById(R.id.FirstEventButton);
        secondCounterButton = findViewById(R.id.SecondEventButton);
        thirdCounterButton = findViewById(R.id.ThirdEventButton);

        firstCounterButtonSharedPrefHelper = new CounterButtonSharedPreferenceHelper(MainActivity.this, CounterButton.FIRST);
        secondCounterButtonSharedPrefHelper = new CounterButtonSharedPreferenceHelper(MainActivity.this, CounterButton.SECOND);
        thirdCounterButtonSharedPrefHelper = new CounterButtonSharedPreferenceHelper(MainActivity.this, CounterButton.THIRD);

        settingsButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                // Create an Intent to start the SettingsActivity
                goToSettingsActivity();
            }
        });
    }

    @Override
    protected void onStart()
    {
        super.onStart();

        if(
            firstCounterButtonSharedPrefHelper.getCounterButtonName(CounterButton.FIRST) == null ||
            secondCounterButtonSharedPrefHelper.getCounterButtonName(CounterButton.SECOND) == null ||
            thirdCounterButtonSharedPrefHelper.getCounterButtonName(CounterButton.THIRD) == null) {

            goToSettingsActivity();

        } else {
            firstCounterButton.setText(firstCounterButtonSharedPrefHelper.getCounterButtonName(CounterButton.FIRST));
            secondCounterButton.setText(secondCounterButtonSharedPrefHelper.getCounterButtonName(CounterButton.SECOND));
            thirdCounterButton.setText(thirdCounterButtonSharedPrefHelper.getCounterButtonName(CounterButton.THIRD));
        }

    }

    private void goToSettingsActivity() {
        Intent intent = new Intent(MainActivity.this, SettingsActivity.class);
        startActivity(intent);
    }
}